if(UNIX OR MINGW)
  # does it makes sense to use different compiler suites at the same time for compiling?
  if(CMAKE_C_COMPILER_ID STREQUAL CMAKE_CXX_COMPILER_ID)
    if(EXISTS ${CMAKE_PLATFORM_PATH}/unix/compiler/${CMAKE_C_COMPILER_ID}.cmake)
      include (${CMAKE_PLATFORM_PATH}/unix/compiler/${CMAKE_C_COMPILER_ID}.cmake)
    else()
      message(FATAL_ERROR "${CMAKE_C_COMPILER_ID} is not a supported compiler!")
    endif()
  else()
    message(FATAL_ERROR "use only compiler from the same suite, like gcc and g++ or clang and clang++")
  endif()
  include(${CMAKE_PLATFORM_PATH}/unix/platform.cmake)
elseif(WIN32)
  include(${CMAKE_PLATFORM_PATH}/win32/platform.cmake)
endif()
