/*
Copyright (C) 2011 Mark Chandler (Desura Net Pty Ltd)
Copyright (C) 2014 Bad Juju Games, Inc.

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software Foundation,
Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301 USA.

Contact us at legal@badjuju.com.

*/

#include "Common.h"
#include "User.h"
#include "usercore/UserCoreI.h"
#include <branding/usercore_version.h>

gcString g_szUserCoreVersion("{0}.{1}.{2}.{3}", VERSION_MAJOR, VERSION_MINOR, VERSION_BUILDNO, VERSION_EXTEND);


namespace UserCore
{

	const char* GetUserCoreVersion()
	{
		return g_szUserCoreVersion.c_str();
	}

extern "C"
{

	CEXPORT void* FactoryBuilderUC(const char* name)
	{
		gcString strName(name);

		if (strName == USERCORE)
		{
			UserCore::User* temp = new UserCore::User();
			return temp;
		}
		else if (strName  == USERCORE_VER)
		{
			return (void *)&GetUserCoreVersion;
		}
		else if (strName == USERCORE_GETLOGIN)
		{
			return (void *)&UserCore::User::getLoginInfo;
		}
		else if (strName == USERCORE_GETITEMSTATUS)
		{
			return (void*)&UserCore::Item::ItemHandle::getStatusStr_s;
		}

		return nullptr;
	}

}
}
